#ifndef MLINK_IOCTLS_H
#define MLINK_IOCTLS_H

#define ML_IOC_MAGIC 0xdc

#define ML_IOC_RESET	          _IO  (ML_IOC_MAGIC, 0) /* Hard reset AMCC and M-Link */
#define ML_IOC_GET_DRIVER_VERSION _IOR (ML_IOC_MAGIC, 1, unsigned long) /* get driver version */
#define ML_IOC_GET_DRIVER_REVISION _IOR (ML_IOC_MAGIC, 2, unsigned long) /* get driver revision */
//#define ML_IOC_START_RUN_MODE_DMA _IOW (ML_IOC_MAGIC, 11, ssp_ring_t) /* receive data from device */
//#define ML_IOC_GET_LATENCY        _IOR (ML_IOC_MAGIC, 13, unsigned char) /* Get latency */
//#define ML_IOC_SET_LATENCY        _IOW (ML_IOC_MAGIC, 14, unsigned char) /* Set latency */
//#define ML_IOC_DMA_STOP	          _IO  (ML_IOC_MAGIC, 19) /* stop any DMA transfer */
//#define ML_IOC_DMA_TRANSFERRED    _IOW (ML_IOC_MAGIC, 27, size_t)
//#define ML_IOC_SEND_DWORD         _IOW (ML_IOC_MAGIC, 30, unsigned int)
//#define ML_IOC_RECV_DWORD         _IOR (ML_IOC_MAGIC, 31, unsigned int)
#define ML_IOC_DMA_SEND	          _IOW (ML_IOC_MAGIC, 32, ml_dmaop_ro_t) /* send data to device */
#define ML_IOC_DMA_RECV	          _IOWR(ML_IOC_MAGIC, 33, ml_dmaop_t) /* recv data from device */
//#define ML_IOC_SET_RUN_MODE       _IOW (ML_IOC_MAGIC, 34, unsigned int)
//#define ML_IOC_GET_DMA_SIZE       _IOR (ML_IOC_MAGIC, 36, unsigned long) /* bytes */
//#define ML_IOC_DMA_ALLOC          _IOW (ML_IOC_MAGIC, 37, unsigned long)
//#define ML_IOC_DMA_FREE           _IO  (ML_IOC_MAGIC, 38)
//#define ML_IOC_GET_DMA_PHYS       _IOR (ML_IOC_MAGIC, 39, unsigned long)
//#define ML_IOC_PIO_SEND	          _IOW (ML_IOC_MAGIC, 43, ml_dmaop_ro_t) /* send data to device, program I/O  */
//#define ML_IOC_PIO_RECV	          _IOWR(ML_IOC_MAGIC, 44, ml_dmaop_t) /* recv data from device, program I/O */
//#define ML_IOC_XILINX_LOOP_MODE   _IOW (ML_IOC_MAGIC, 45, int) /* 0 = normal, 1 = Xilinx LOOP mode */
//#define ML_IOC_EXT_LOOP_MODE      _IOW (ML_IOC_MAGIC, 46, int) /* 0 = normal, 1 = TLK SerDes LOOP mode */
#define ML_IOC_GET_STATUS         _IOR (ML_IOC_MAGIC, 47, mlink_status_t)
#define ML_IOC_GET_CAPS           _IOR (ML_IOC_MAGIC, 48, mlink_caps_t) /* device capabilities */
//#define ML_IOC_TEST_SIGNAL        _IO (ML_IOC_MAGIC, 49) /* test signal */
#define ML_IOC_GET_EVENT          _IOWR (ML_IOC_MAGIC, 50, ml_poll_ev_op_t) /* wait for lcf_data or dma_complete event */
//#define ML_IOC_GET_FRAG_SIZE      _IOR (ML_IOC_MAGIC, 51, unsigned long)
//#define ML_IOC_SET_STRIP_PKT      _IOR (ML_IOC_MAGIC, 52, unsigned long)
//#define ML_IOC_LOCAL_JTAG_MODE    _IOW (ML_IOC_MAGIC, 53, unsigned long)
//#define ML_IOC_REMOTE_RESET       _IO (ML_IOC_MAGIC, 54) /* send special packet with 5 CE */

#define ML_IOC_WRITE_PORT      _IO (ML_IOC_MAGIC, 56)
#define ML_IOC_READ_PORT       _IO (ML_IOC_MAGIC, 57)

#endif /* MLINK_IOCTLS_H */
